DeclareModule CkCodeSign
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.l ckHeartbeatMs(obj.i)
  Declare setCkHeartbeatMs(obj.i, value.l)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.s ckUncommonOptions(obj.i)
  Declare setCkUncommonOptions(obj.i, value.s)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckAddSignature(obj.i, path.s, cert.i, options.i)
  Declare.i ckAddSignatureAsync(obj.i, path.s, cert.i, options.i)
  Declare.l ckRemoveSignature(obj.i, path.s)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckVerifySignature(obj.i, path.s, sigInfo.i)
EndDeclareModule

Module CkCodeSign
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.i ckiMsii(obj.i, arg1.s, arg2.i, arg3.i)
  PrototypeC.l cklMsii(obj.i, arg1.s, arg2.i, arg3.i)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.l cklMsi(obj.i, arg1.s, arg2.i)
  PrototypeC.i CkCodeSignCreate()
  PrototypeC CkCodeSignDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkCodeSignLibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkCodeSignLibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
  CompilerEndSelect
  Global CodeSignCreate.CkCodeSignCreate = GetFunction(CkCodeSignLibId,"CkCodeSignU_CreateW")
  Global CodeSignDispose.CkCodeSignDispose = GetFunction(CkCodeSignLibId,"CkCodeSignU_DisposeW")
  Global CodeSignDebugLogFilePath.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_debugLogFilePathW")
  Global CodeSignPSetDebugLogFilePath.cksPropSet = GetFunction(CkCodeSignLibId,"CkCodeSignU_putDebugLogFilePathW")
  Global CodeSignHeartbeatMs.cklPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_getHeartbeatMsW")
  Global CodeSignPSetHeartbeatMs.cklPropSet = GetFunction(CkCodeSignLibId,"CkCodeSignU_putHeartbeatMsW")
  Global CodeSignLastErrorHtml.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_lastErrorHtmlW")
  Global CodeSignLastErrorText.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_lastErrorTextW")
  Global CodeSignLastErrorXml.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_lastErrorXmlW")
  Global CodeSignLastMethodSuccess.cklPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_getLastMethodSuccessW")
  Global CodeSignPSetLastMethodSuccess.cklPropSet = GetFunction(CkCodeSignLibId,"CkCodeSignU_putLastMethodSuccessW")
  Global CodeSignUncommonOptions.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_uncommonOptionsW")
  Global CodeSignPSetUncommonOptions.cksPropSet = GetFunction(CkCodeSignLibId,"CkCodeSignU_putUncommonOptionsW")
  Global CodeSignVerboseLogging.cklPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_getVerboseLoggingW")
  Global CodeSignPSetVerboseLogging.cklPropSet = GetFunction(CkCodeSignLibId,"CkCodeSignU_putVerboseLoggingW")
  Global CodeSignVersion.cksPropGet = GetFunction(CkCodeSignLibId,"CkCodeSignU_versionW")
  Global CodeSignAddSignature.cklMsii = GetFunction(CkCodeSignLibId,"CkCodeSignU_AddSignatureW")
  Global CodeSignAddSignatureAsync.ckiMsii = GetFunction(CkCodeSignLibId,"CkCodeSignU_AddSignatureAsyncW")
  Global CodeSignRemoveSignature.cklMs = GetFunction(CkCodeSignLibId,"CkCodeSignU_RemoveSignatureW")
  Global CodeSignSaveLastError.cklMs = GetFunction(CkCodeSignLibId,"CkCodeSignU_SaveLastErrorW")
  Global CodeSignVerifySignature.cklMsi = GetFunction(CkCodeSignLibId,"CkCodeSignU_VerifySignatureW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn CodeSignCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn CodeSignDispose(obj) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(CodeSignDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn CodeSignPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.l ckHeartbeatMs(obj.i) : ProcedureReturn CodeSignHeartbeatMs(obj) : EndProcedure
  Procedure setCkHeartbeatMs(obj.i, value.l) : ProcedureReturn CodeSignPSetHeartbeatMs(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(CodeSignLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(CodeSignLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(CodeSignLastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn CodeSignLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn CodeSignPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.s ckUncommonOptions(obj.i) : ProcedureReturn PeekS(CodeSignUncommonOptions(obj)) : EndProcedure
  Procedure setCkUncommonOptions(obj.i, value.s) : ProcedureReturn CodeSignPSetUncommonOptions(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn CodeSignVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn CodeSignPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(CodeSignVersion(obj)) : EndProcedure
  Procedure.l ckAddSignature(obj.i, path.s, cert.i, options.i) :  ProcedureReturn CodeSignAddSignature(obj, path, cert, options) :  EndProcedure
  Procedure.i ckAddSignatureAsync(obj.i, path.s, cert.i, options.i) :  ProcedureReturn CodeSignAddSignatureAsync(obj, path, cert, options) :  EndProcedure
  Procedure.l ckRemoveSignature(obj.i, path.s) :  ProcedureReturn CodeSignRemoveSignature(obj, path) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn CodeSignSaveLastError(obj, path) :  EndProcedure
  Procedure.l ckVerifySignature(obj.i, path.s, sigInfo.i) :  ProcedureReturn CodeSignVerifySignature(obj, path, sigInfo) :  EndProcedure
EndModule

