DeclareModule CkDns
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.l ckHeartbeatMs(obj.i)
  Declare setCkHeartbeatMs(obj.i, value.l)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.l ckMaxWaitMs(obj.i)
  Declare setCkMaxWaitMs(obj.i, value.l)
  Declare.l ckNumNameservers(obj.i)
  Declare.l ckTlsPref(obj.i)
  Declare setCkTlsPref(obj.i, value.l)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare ckAddDefaultNameservers(obj.i)
  Declare ckAddNameserver(obj.i, ipAddr.s, supportsTls.l)
  Declare.s ckGetNameserver(obj.i, index.l)
  Declare.l ckQuery(obj.i, recordType.s, domain.s, answer.i)
  Declare.i ckQueryAsync(obj.i, recordType.s, domain.s, answer.i)
  Declare ckRemoveAllNameservers(obj.i)
  Declare ckRemoveNameserver(obj.i, ipAddr.s)
  Declare.l ckSaveLastError(obj.i, path.s)
EndDeclareModule

Module CkDns
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.i ckiMssi(obj.i, arg1.s, arg2.s, arg3.i)
  PrototypeC.i cksMl(obj.i, arg1.l)
  PrototypeC ckvMs(obj.i, arg1.s)
  PrototypeC ckvM(obj.i)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC ckvMsl(obj.i, arg1.s, arg2.l)
  PrototypeC.l cklMssi(obj.i, arg1.s, arg2.s, arg3.i)
  PrototypeC.i CkDnsCreate()
  PrototypeC CkDnsDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkDnsLibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkDnsLibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
      CompilerIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbM1-9_5_0.dylib")
      CompilerElse
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.dylib")
      CompilerEndIf
    CompilerCase #PB_OS_Linux
      ; Note: The full path of the .so shared library will be required when running from a compiled executable on Linux.
      ; See https://www.purebasic.fr/english/viewtopic.php?t=79882
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm32
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm64-9_5_0.so")
      CompilerElse
        CkDnsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.so")
      CompilerEndIf
  CompilerEndSelect
  Global DnsCreate.CkDnsCreate = GetFunction(CkDnsLibId,"CkDnsU_CreateW")
  Global DnsDispose.CkDnsDispose = GetFunction(CkDnsLibId,"CkDnsU_DisposeW")
  Global DnsDebugLogFilePath.cksPropGet = GetFunction(CkDnsLibId,"CkDnsU_debugLogFilePathW")
  Global DnsPSetDebugLogFilePath.cksPropSet = GetFunction(CkDnsLibId,"CkDnsU_putDebugLogFilePathW")
  Global DnsHeartbeatMs.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getHeartbeatMsW")
  Global DnsPSetHeartbeatMs.cklPropSet = GetFunction(CkDnsLibId,"CkDnsU_putHeartbeatMsW")
  Global DnsLastErrorHtml.cksPropGet = GetFunction(CkDnsLibId,"CkDnsU_lastErrorHtmlW")
  Global DnsLastErrorText.cksPropGet = GetFunction(CkDnsLibId,"CkDnsU_lastErrorTextW")
  Global DnsLastErrorXml.cksPropGet = GetFunction(CkDnsLibId,"CkDnsU_lastErrorXmlW")
  Global DnsLastMethodSuccess.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getLastMethodSuccessW")
  Global DnsPSetLastMethodSuccess.cklPropSet = GetFunction(CkDnsLibId,"CkDnsU_putLastMethodSuccessW")
  Global DnsMaxWaitMs.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getMaxWaitMsW")
  Global DnsPSetMaxWaitMs.cklPropSet = GetFunction(CkDnsLibId,"CkDnsU_putMaxWaitMsW")
  Global DnsNumNameservers.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getNumNameserversW")
  Global DnsTlsPref.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getTlsPrefW")
  Global DnsPSetTlsPref.cklPropSet = GetFunction(CkDnsLibId,"CkDnsU_putTlsPrefW")
  Global DnsVerboseLogging.cklPropGet = GetFunction(CkDnsLibId,"CkDnsU_getVerboseLoggingW")
  Global DnsPSetVerboseLogging.cklPropSet = GetFunction(CkDnsLibId,"CkDnsU_putVerboseLoggingW")
  Global DnsVersion.cksPropGet = GetFunction(CkDnsLibId,"CkDnsU_versionW")
  Global DnsAddDefaultNameservers.ckvM = GetFunction(CkDnsLibId,"CkDnsU_AddDefaultNameserversW")
  Global DnsAddNameserver.ckvMsl = GetFunction(CkDnsLibId,"CkDnsU_AddNameserverW")
  Global DnsGetNameserver.cksMl = GetFunction(CkDnsLibId,"CkDnsU_getNameserverW")
  Global DnsQuery.cklMssi = GetFunction(CkDnsLibId,"CkDnsU_QueryW")
  Global DnsQueryAsync.ckiMssi = GetFunction(CkDnsLibId,"CkDnsU_QueryAsyncW")
  Global DnsRemoveAllNameservers.ckvM = GetFunction(CkDnsLibId,"CkDnsU_RemoveAllNameserversW")
  Global DnsRemoveNameserver.ckvMs = GetFunction(CkDnsLibId,"CkDnsU_RemoveNameserverW")
  Global DnsSaveLastError.cklMs = GetFunction(CkDnsLibId,"CkDnsU_SaveLastErrorW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn DnsCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn DnsDispose(obj) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(DnsDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn DnsPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.l ckHeartbeatMs(obj.i) : ProcedureReturn DnsHeartbeatMs(obj) : EndProcedure
  Procedure setCkHeartbeatMs(obj.i, value.l) : ProcedureReturn DnsPSetHeartbeatMs(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(DnsLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(DnsLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(DnsLastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn DnsLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn DnsPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.l ckMaxWaitMs(obj.i) : ProcedureReturn DnsMaxWaitMs(obj) : EndProcedure
  Procedure setCkMaxWaitMs(obj.i, value.l) : ProcedureReturn DnsPSetMaxWaitMs(obj,value) : EndProcedure
  Procedure.l ckNumNameservers(obj.i) : ProcedureReturn DnsNumNameservers(obj) : EndProcedure
  Procedure.l ckTlsPref(obj.i) : ProcedureReturn DnsTlsPref(obj) : EndProcedure
  Procedure setCkTlsPref(obj.i, value.l) : ProcedureReturn DnsPSetTlsPref(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn DnsVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn DnsPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(DnsVersion(obj)) : EndProcedure
  Procedure ckAddDefaultNameservers(obj.i) :  ProcedureReturn DnsAddDefaultNameservers(obj) :  EndProcedure
  Procedure ckAddNameserver(obj.i, ipAddr.s, supportsTls.l) :  ProcedureReturn DnsAddNameserver(obj, ipAddr, supportsTls) :  EndProcedure
  Procedure.s ckGetNameserver(obj.i, index.l) :  ProcedureReturn PeekS(DnsGetNameserver(obj, index)) :  EndProcedure
  Procedure.l ckQuery(obj.i, recordType.s, domain.s, answer.i) :  ProcedureReturn DnsQuery(obj, recordType, domain, answer) :  EndProcedure
  Procedure.i ckQueryAsync(obj.i, recordType.s, domain.s, answer.i) :  ProcedureReturn DnsQueryAsync(obj, recordType, domain, answer) :  EndProcedure
  Procedure ckRemoveAllNameservers(obj.i) :  ProcedureReturn DnsRemoveAllNameservers(obj) :  EndProcedure
  Procedure ckRemoveNameserver(obj.i, ipAddr.s) :  ProcedureReturn DnsRemoveNameserver(obj, ipAddr) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn DnsSaveLastError(obj, path) :  EndProcedure
EndModule

