DeclareModule CkPkcs11
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.l ckNumCerts(obj.i)
  Declare.s ckSharedLibPath(obj.i)
  Declare setCkSharedLibPath(obj.i, value.s)
  Declare.s ckSigContextPin(obj.i)
  Declare setCkSigContextPin(obj.i, value.s)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckCloseSession(obj.i)
  Declare.l ckCreatePkcs11Object(obj.i, attrs.i)
  Declare.l ckDestroyObject(obj.i, hObject.l)
  Declare.l ckDiscover(obj.i, onlyTokensPresent.l, json.i)
  Declare.l ckExportPublicKey(obj.i, keyHandle.l, pubKey.i)
  Declare.l ckFindAllCerts(obj.i)
  Declare.l ckFindAllKeys(obj.i, keyClass.s, json.i)
  Declare.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i)
  Declare.l ckFindObject(obj.i, jsonTemplate.i)
  Declare.l ckGenEcKey(obj.i, publicAttrs.i, privateAttrs.i, jsonOut.i, pubKey.i)
  Declare.l ckGenRsaKey(obj.i, publicAttrs.i, privateAttrs.i, jsonOut.i, pubKey.i)
  Declare.l ckGenSecretKey(obj.i, keyType.s, jsonTemplate.i)
  Declare.l ckGetCert(obj.i, index.l, cert.i)
  Declare.l ckImportPrivateKey(obj.i, privKey.i, jsonTemplate.i)
  Declare.l ckImportSshKey(obj.i, sshKey.i, jsonTemplate.i)
  Declare.l ckInitialize(obj.i)
  Declare.l ckInitPin(obj.i, pin.s)
  Declare.l ckInitToken(obj.i, slotId.l, pin.s, tokenLabel.s)
  Declare.l ckLogin(obj.i, userType.l, pin.s)
  Declare.l ckLogout(obj.i)
  Declare.l ckOpenSession(obj.i, slotId.l, readWrite.l)
  Declare.l ckQuickSession(obj.i, userType.l, pin.s)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckSetPin(obj.i, oldPin.s, newPin.s)
EndDeclareModule

Module CkPkcs11
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklM(obj.i)
  PrototypeC.l cklMll(obj.i, arg1.l, arg2.l)
  PrototypeC.l cklMl(obj.i, arg1.l)
  PrototypeC.l cklMsi(obj.i, arg1.s, arg2.i)
  PrototypeC.l cklMi(obj.i, arg1.i)
  PrototypeC.l cklMss(obj.i, arg1.s, arg2.s)
  PrototypeC.l cklMssi(obj.i, arg1.s, arg2.s, arg3.i)
  PrototypeC.l cklMlss(obj.i, arg1.l, arg2.s, arg3.s)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.l cklMls(obj.i, arg1.l, arg2.s)
  PrototypeC.l cklMli(obj.i, arg1.l, arg2.i)
  PrototypeC.l cklMiiii(obj.i, arg1.i, arg2.i, arg3.i, arg4.i)
  PrototypeC.l cklMii(obj.i, arg1.i, arg2.i)
  PrototypeC.i CkPkcs11Create()
  PrototypeC CkPkcs11Dispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
      CompilerIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPbM1-9_5_0.dylib")
      CompilerElse
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.dylib")
      CompilerEndIf
    CompilerCase #PB_OS_Linux
      ; Note: The full path of the .so shared library will be required when running from a compiled executable on Linux.
      ; See https://www.purebasic.fr/english/viewtopic.php?t=79882
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm32
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm64-9_5_0.so")
      CompilerElse
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.so")
      CompilerEndIf
  CompilerEndSelect
  Global Pkcs11Create.CkPkcs11Create = GetFunction(CkPkcs11LibId,"CkPkcs11U_CreateW")
  Global Pkcs11Dispose.CkPkcs11Dispose = GetFunction(CkPkcs11LibId,"CkPkcs11U_DisposeW")
  Global Pkcs11DebugLogFilePath.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_debugLogFilePathW")
  Global Pkcs11PSetDebugLogFilePath.cksPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putDebugLogFilePathW")
  Global Pkcs11LastErrorHtml.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorHtmlW")
  Global Pkcs11LastErrorText.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorTextW")
  Global Pkcs11LastErrorXml.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorXmlW")
  Global Pkcs11LastMethodSuccess.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getLastMethodSuccessW")
  Global Pkcs11PSetLastMethodSuccess.cklPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putLastMethodSuccessW")
  Global Pkcs11NumCerts.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getNumCertsW")
  Global Pkcs11SharedLibPath.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_sharedLibPathW")
  Global Pkcs11PSetSharedLibPath.cksPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putSharedLibPathW")
  Global Pkcs11SigContextPin.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_sigContextPinW")
  Global Pkcs11PSetSigContextPin.cksPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putSigContextPinW")
  Global Pkcs11VerboseLogging.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getVerboseLoggingW")
  Global Pkcs11PSetVerboseLogging.cklPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putVerboseLoggingW")
  Global Pkcs11Version.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_versionW")
  Global Pkcs11CloseSession.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_CloseSessionW")
  Global Pkcs11CreatePkcs11Object.cklMi = GetFunction(CkPkcs11LibId,"CkPkcs11U_CreatePkcs11ObjectW")
  Global Pkcs11DestroyObject.cklMl = GetFunction(CkPkcs11LibId,"CkPkcs11U_DestroyObjectW")
  Global Pkcs11Discover.cklMli = GetFunction(CkPkcs11LibId,"CkPkcs11U_DiscoverW")
  Global Pkcs11ExportPublicKey.cklMli = GetFunction(CkPkcs11LibId,"CkPkcs11U_ExportPublicKeyW")
  Global Pkcs11FindAllCerts.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindAllCertsW")
  Global Pkcs11FindAllKeys.cklMsi = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindAllKeysW")
  Global Pkcs11FindCert.cklMssi = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindCertW")
  Global Pkcs11FindObject.cklMi = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindObjectW")
  Global Pkcs11GenEcKey.cklMiiii = GetFunction(CkPkcs11LibId,"CkPkcs11U_GenEcKeyW")
  Global Pkcs11GenRsaKey.cklMiiii = GetFunction(CkPkcs11LibId,"CkPkcs11U_GenRsaKeyW")
  Global Pkcs11GenSecretKey.cklMsi = GetFunction(CkPkcs11LibId,"CkPkcs11U_GenSecretKeyW")
  Global Pkcs11GetCert.cklMli = GetFunction(CkPkcs11LibId,"CkPkcs11U_GetCertW")
  Global Pkcs11ImportPrivateKey.cklMii = GetFunction(CkPkcs11LibId,"CkPkcs11U_ImportPrivateKeyW")
  Global Pkcs11ImportSshKey.cklMii = GetFunction(CkPkcs11LibId,"CkPkcs11U_ImportSshKeyW")
  Global Pkcs11Initialize.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitializeW")
  Global Pkcs11InitPin.cklMs = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitPinW")
  Global Pkcs11InitToken.cklMlss = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitTokenW")
  Global Pkcs11Login.cklMls = GetFunction(CkPkcs11LibId,"CkPkcs11U_LoginW")
  Global Pkcs11Logout.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_LogoutW")
  Global Pkcs11OpenSession.cklMll = GetFunction(CkPkcs11LibId,"CkPkcs11U_OpenSessionW")
  Global Pkcs11QuickSession.cklMls = GetFunction(CkPkcs11LibId,"CkPkcs11U_QuickSessionW")
  Global Pkcs11SaveLastError.cklMs = GetFunction(CkPkcs11LibId,"CkPkcs11U_SaveLastErrorW")
  Global Pkcs11SetPin.cklMss = GetFunction(CkPkcs11LibId,"CkPkcs11U_SetPinW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn Pkcs11Create() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn Pkcs11Dispose(obj) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(Pkcs11DebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn Pkcs11PSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn Pkcs11LastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn Pkcs11PSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.l ckNumCerts(obj.i) : ProcedureReturn Pkcs11NumCerts(obj) : EndProcedure
  Procedure.s ckSharedLibPath(obj.i) : ProcedureReturn PeekS(Pkcs11SharedLibPath(obj)) : EndProcedure
  Procedure setCkSharedLibPath(obj.i, value.s) : ProcedureReturn Pkcs11PSetSharedLibPath(obj,value) : EndProcedure
  Procedure.s ckSigContextPin(obj.i) : ProcedureReturn PeekS(Pkcs11SigContextPin(obj)) : EndProcedure
  Procedure setCkSigContextPin(obj.i, value.s) : ProcedureReturn Pkcs11PSetSigContextPin(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn Pkcs11VerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn Pkcs11PSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(Pkcs11Version(obj)) : EndProcedure
  Procedure.l ckCloseSession(obj.i) :  ProcedureReturn Pkcs11CloseSession(obj) :  EndProcedure
  Procedure.l ckCreatePkcs11Object(obj.i, attrs.i) :  ProcedureReturn Pkcs11CreatePkcs11Object(obj, attrs) :  EndProcedure
  Procedure.l ckDestroyObject(obj.i, hObject.l) :  ProcedureReturn Pkcs11DestroyObject(obj, hObject) :  EndProcedure
  Procedure.l ckDiscover(obj.i, onlyTokensPresent.l, json.i) :  ProcedureReturn Pkcs11Discover(obj, onlyTokensPresent, json) :  EndProcedure
  Procedure.l ckExportPublicKey(obj.i, keyHandle.l, pubKey.i) :  ProcedureReturn Pkcs11ExportPublicKey(obj, keyHandle, pubKey) :  EndProcedure
  Procedure.l ckFindAllCerts(obj.i) :  ProcedureReturn Pkcs11FindAllCerts(obj) :  EndProcedure
  Procedure.l ckFindAllKeys(obj.i, keyClass.s, json.i) :  ProcedureReturn Pkcs11FindAllKeys(obj, keyClass, json) :  EndProcedure
  Procedure.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i) :  ProcedureReturn Pkcs11FindCert(obj, certPart, partValue, cert) :  EndProcedure
  Procedure.l ckFindObject(obj.i, jsonTemplate.i) :  ProcedureReturn Pkcs11FindObject(obj, jsonTemplate) :  EndProcedure
  Procedure.l ckGenEcKey(obj.i, publicAttrs.i, privateAttrs.i, jsonOut.i, pubKey.i) :  ProcedureReturn Pkcs11GenEcKey(obj, publicAttrs, privateAttrs, jsonOut, pubKey) :  EndProcedure
  Procedure.l ckGenRsaKey(obj.i, publicAttrs.i, privateAttrs.i, jsonOut.i, pubKey.i) :  ProcedureReturn Pkcs11GenRsaKey(obj, publicAttrs, privateAttrs, jsonOut, pubKey) :  EndProcedure
  Procedure.l ckGenSecretKey(obj.i, keyType.s, jsonTemplate.i) :  ProcedureReturn Pkcs11GenSecretKey(obj, keyType, jsonTemplate) :  EndProcedure
  Procedure.l ckGetCert(obj.i, index.l, cert.i) :  ProcedureReturn Pkcs11GetCert(obj, index, cert) :  EndProcedure
  Procedure.l ckImportPrivateKey(obj.i, privKey.i, jsonTemplate.i) :  ProcedureReturn Pkcs11ImportPrivateKey(obj, privKey, jsonTemplate) :  EndProcedure
  Procedure.l ckImportSshKey(obj.i, sshKey.i, jsonTemplate.i) :  ProcedureReturn Pkcs11ImportSshKey(obj, sshKey, jsonTemplate) :  EndProcedure
  Procedure.l ckInitialize(obj.i) :  ProcedureReturn Pkcs11Initialize(obj) :  EndProcedure
  Procedure.l ckInitPin(obj.i, pin.s) :  ProcedureReturn Pkcs11InitPin(obj, pin) :  EndProcedure
  Procedure.l ckInitToken(obj.i, slotId.l, pin.s, tokenLabel.s) :  ProcedureReturn Pkcs11InitToken(obj, slotId, pin, tokenLabel) :  EndProcedure
  Procedure.l ckLogin(obj.i, userType.l, pin.s) :  ProcedureReturn Pkcs11Login(obj, userType, pin) :  EndProcedure
  Procedure.l ckLogout(obj.i) :  ProcedureReturn Pkcs11Logout(obj) :  EndProcedure
  Procedure.l ckOpenSession(obj.i, slotId.l, readWrite.l) :  ProcedureReturn Pkcs11OpenSession(obj, slotId, readWrite) :  EndProcedure
  Procedure.l ckQuickSession(obj.i, userType.l, pin.s) :  ProcedureReturn Pkcs11QuickSession(obj, userType, pin) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn Pkcs11SaveLastError(obj, path) :  EndProcedure
  Procedure.l ckSetPin(obj.i, oldPin.s, newPin.s) :  ProcedureReturn Pkcs11SetPin(obj, oldPin, newPin) :  EndProcedure
EndModule

